10  KEY OFF:WIDTH 40:COLOR 7,1:CLS
20  LOCATE 8,16:PRINT"HALLEY'S":LOCATE 10,17:PRINT"COMET"
30  LOCATE 12,15:PRINT"1985-1986"
40  LOCATE 22,12:PRINT"for PC Compatibles":LOCATE 24,16:PRINT"MAY 1985"
50  FOR UU=1 TO 1000:NEXT UU:SCREEN 0
60  CLS:DIM DM(12):WIDTH 80
70  CLS:COLOR 7,1,9:CLS
80  LOCATE 8,28:PRINT"COMPOSITE PROGRAM BY"
90  LOCATE 10,30:PRINT"MICHAEL C. ROBEL"
100  '   LOCATE 12,32:PRINT"HOUSTON, TX":LOCATE 25,80
110  LOCATE 25,80
120  FOR VV= 1 TO 1000:NEXT VV
130  CLS:COLOR 7,1,9:CLS
140  PRINT:PRINT "     ";
150  PRINT "(Public Domain, from the library of Astronomer's RBBS 305-268-8576)"
155  PRINT
160  PRINT"           HALLEY'S COMET EPHEMERIS AND INFORMATION           MAY 1985"
170  LOCATE 8,10:PRINT"(1) INFORMATION ON HALLEY'S COMET"
180  LOCATE 10,10:PRINT"(2) INFORMATION ON TELESCOPES"
190  LOCATE 12,10:PRINT"(3) INFORMATION ON YOUR LOCATION"
200  LOCATE 14,10:PRINT"(4) LOCATION OF HALLEY'S COMET"
210  LOCATE 16,10:PRINT"(5) QUIT"
220  LOCATE 21,10:INPUT "ENTER A NUMBER ",N$: IF N$ <>"1" AND N$<>"2" AND N$<>"3"  AND N$<>"4" AND N$<>"5" THEN 130
230  IF N$="1" THEN 3100
240  IF N$="2" THEN 3240
250  IF N$="3" THEN 3470
260  IF N$="5" THEN COLOR 7,0,0,:SCREEN 0,0,0:CLS:END
270  COLOR 1,7,1:CLS
280  PI=3.14159
290  CO$="COMET HALLEY"
300  PH=1986.11
310  PL=170.011
320  AN=58.154
330  PY=76.0081
340  SM=17.9435
350  EO=0.9673
360  IO=162.238
370  REM --------------------------------------------------------------
380  CLS
390  LOCATE 2,20:PRINT"            ";CO$
400  LOCATE 5,20:PRINT"COORDINATES FOR DATES BETWEEN 1946 AND 2026"
410  REM --------------------------------------------------------------
420  REM                   INPUT THE DATE
430  REM --------------------------------------------------------------
440  PRINT:PRINT:PRINT:PRINT"INPUT YEAR"
450  INPUT Y
460  IF Y<1946 OR Y>2026 THEN GOTO 440
470  PRINT:PRINT"INPUT MONTH (1 TO 12)"
480  INPUT M
490  IF M<1 OR M>12 THEN GOTO 470
500  PRINT:PRINT "INPUT DAY"
510  INPUT D
520  PRINT
530  GOSUB 3700
540  REM --------------------------------------------------------------
550  REM      CALCULATION FOR THE COMET
560  REM --------------------------------------------------------------
570  X=PH
580  IF Y>=1986 THEN Z=1984
590  IF Y<1986 THEN Z=1988
600  IF Y>=1986 THEN S=0
610  IF Y<1986 THEN S=1
620  GOSUB 2050
630  DS=N
640  B=(360/PY)*(N/365.25)
650  K=B
660  GOSUB 2200
670  B=(K*PI)/180
680  E=B
690  Y1=EO
700  Q=E-(Y1*SIN(E))-B
710  IF ABS(Q)<=1.6999E-05 THEN GOTO 750
720  U=Q/(1-(Y1*COS(E)))
730  E=E-U
740  GOTO 700
750  V=(SQR((1+Y1)/(1-Y1))*TAN(E/2))
760  V=2*ATN(V)
770  V1=(V*180)/PI
780  L=V1+PL
790  R=SM*(1-(Y1*Y1))/(1+Y1*COS(V))
800  F=L-AN
810  F2=IO
820  F1=(F*PI)/180
830  F2=(F2*PI)/180
840  I=(SIN(F1)*SIN(F2))
850  I=ATN(I/SQR(-I*I+1))
860  P=ATN(TAN(F1)*COS(F2))
870  P1=(P*180)/PI+AN
880  IF F>=90 AND F<=270 THEN P1=P1+180
890  IF P1<0 THEN P1=P1 +360
900  P=(P1*PI)/180
910  R2=R*COS(I)
920  REM ------------------------------------------------------------
930  REM               CALCULATIONS FOR THE EARTH
940  REM ------------------------------------------------------------
950  X=1975
960  IF Y>=X THEN Z=1972
970  IF Y<X THEN Z=1976
980  IF Y>=X THEN S=0
990  IF Y<X THEN S=1
1000  GOSUB 2050
1010  T=(360/365.25)*(N/1.00004)
1020  K=T
1030  GOSUB 2200
1040  T=K
1050  T1=(T*PI)/180
1060  C=0.01672
1070  J=T+(360/PI)*C*SIN(T1-0.051943)
1080  J=J+99.5343
1090  IF J>360 THEN J=J-360
1100  IF J<0 THEN J=J+360
1110  H=((J-102.51)*PI)/180
1120  R1=(1-C*C)/(1+C*COS(H))
1130  REM ----------------------------------------------------
1140  REM       COMPUTE ECLIPTIC COORDINATES
1150  REM -----------------------------------------------------
1160  U1=((P1-J)*PI)/180
1170  U2=((J-P1)*PI)/180
1180  IF R2<R1 THEN GOTO 1240
1190  Q1=(R1*SIN(U1))
1200  Q1=Q1/(R2-(R1*COS(U1)))
1210  Q1=ATN(Q1)
1220  Q2=(Q1*180)/PI+P1
1230  GOTO 1280
1240  Q3=(R2*SIN(U2))
1250  Q3=Q3/(R1-(R2*COS(U2)))
1260  Q3=ATN(Q3)
1270  Q2=(Q3*180)/PI+J+180
1280  IF Q2>360 THEN Q2=Q2-360
1290  IF Q2<0 THEN Q2=Q2+360
1300  Q4=(Q2*PI)/180
1310  Q5=(R2*TAN(I)*SIN(Q4-P))
1320  Q5=Q5/(R1*SIN(U1))
1330  Q5=ATN(Q5)
1340  REM ----------------------------------------------------------
1350  REM     CONVERT TO EQUATORIAL COORDINATES
1360  REM ----------------------------------------------------------
1370  E1=0.408931
1380  L1=(SIN(Q5)*COS(E1))
1390  L1=L1+(COS(Q5)*SIN(E1)*SIN(Q4))
1400  M1=ATN(L1/SQR(-L1*L1+1))
1410  Y2=(M1*180)/PI
1420  B1=(TAN(Q4)*COS(E1))
1430  B1=B1-((TAN(Q5)*SIN(E1))/COS(Q4))
1440  G=ATN(B1)
1450  H1=(G*180)/PI
1460  I1=INT(Q2/90)
1470  J1=INT(H1/90)
1480  IF I1-J1=4 OR I1-J1=1 THEN H1=H1+360
1490  IF I1-J1=2 OR I1-J1=3 THEN H1=H1+180
1500  IF I1-J1=-4 THEN H1=H1+360
1510  IF I1-J1=-2 THEN H1=H1-180
1520  N1=H1/15
1530  W=INT((N1-INT(N1))*60+0.5)
1540  IF W=60 THEN N1=N1+1
1550  IF W=60 THEN W=0
1560  K1=ABS(Y2)
1570  W1=INT((K1-INT(K1))*60+0.5)
1580  IF W1=60 THEN G1=G1+1
1590  IF W1=60 THEN W1=0
1600  G1=INT(K1)
1610  IF Y2<0 AND G1<1 THEN W1=-W1
1620  D1=R1*R1+R2*R2
1630  D1=D1-(2*R1*R2*COS(U1))
1640  D2=SQR(D1)
1650  R3=D2/COS(I)
1660  K9=R
1670  GOSUB 2310
1680  R=K9
1690  K9=R3/10
1700  GOSUB 2310
1710  R3=K9*10
1720  MO=4.1:N=3.1
1730  REM IF DS<0 THEN MO=5:N=4.44
1740  REM MA=MO+5*.4343*LOG(R3)
1750  IF DS<0 THEN MA=5.47+5*0.4343*LOG(R3)+11.1*0.4343*LOG(R)
1760  REM MA=MA+N*2.5*.4343*LOG(R)
1770  IF DS>0 THEN MA=4.94+5*0.4343*LOG(R3)+7.68*0.4343*LOG(R)
1780  MA=(INT(10*MA))/10
1790  IF Y2<0 THEN G1=-G1
1800  REM -------------------------------------------------------
1810  REM              PRINT EPHEMERIS FOR DATE
1820  REM -------------------------------------------------------
1830  CLS
1840  LOCATE 1,30:PRINT"DATA FOR "+CO$
1850  LOCATE 3,1:PRINT"GMT DATE: M/D/Y=";M;"/";D;"/";Y
1860  PRINT"DAYS TO PERIHELION ";INT(DS)
1870  PRINT
1880  PRINT"EQUATORIAL COORDINATES FOR GMT DATE AT 0 HOURS GMT:"
1890  PRINT"RIGHT ASCENSION:"; INT(N1);"HRS";W;"MIN"
1900  PRINT"DECLINATION:"; G1;"DEG";W1;"MIN"
1910  PRINT
1920  PRINT "DISTANCES:"
1930  PRINT"COMET TO SUN"; R;"AU",R*92.96;"MILLIONS OF MILES"
1940  PRINT "COMET TO EARTH";R3;"AU",R3*92.96;"MILLIONS OF MILES"
1950  PRINT
1960  PRINT"PREDICTED MAGNITUDE";MA
1970  GOTO 2350
1980  PRINT"PRESS O FOR ANOTHER DATE"
1990  IF INKEY$="O" THEN GOTO 2010
2000  GOTO 1990
2010  PRINT
2020  GOTO 440
2030  REM -----------------------------------------------------------
2040  REM     SUBROUTINE FOR DAYS TO PERIHELION
2050  A=(Y-Z)/4
2060  A1=INT(A+S)
2070  N=365*(Y-X+S)+A1
2080  IF INT(A)<>A THEN GOTO 2100
2090  IF (M=2 AND D<29) OR M=1 THEN N=N-1
2100  IF M>2 THEN GOTO 2140
2110  M2=M-1
2120  M2=31*M2
2130  GOTO 2160
2140  M2=M+1
2150  M2=INT(30.6*M2)-63
2160  N=N+M2+D-365*S
2170  RETURN
2180  REM -------------------------------------------------------------
2190  REM:  PLACE BETWEEN 0 AND 360 DEG
2200  IF K<0 THEN GOTO 2220
2210  IF K>360 THEN GOTO 2250
2220  K=K+360
2230  IF K=>0 THEN GOTO 2280
2240  GOTO 2220
2250  K=K-360
2260  IF K<=360 THEN GOTO 2280
2270  GOTO 2250
2280  RETURN
2290  REM -------------------------------------------------------------
2300  REM: ROUND OFF SUBROUTINE
2310  K9=K9*1000
2320  K9=INT(K9+0.5)
2330  K9=K9/1000
2340  RETURN
2350  REM COMPUTATION OF AZIMUTH AND ALTITUDE
2360  REM             COMPUTATION OF GST
2370  REM -------------------------------------------------------------
2380  DM(1)=0:DM(2)=31:DM(3)=59:DM(4)=90:DM(5)=120:DM(6)=151
2390  DM(7)=181:DM(8)=212:DM(9)=243:DM(10)=273:DM(11)=304:DM(12)=334
2400  DTOT=DM(M)+D
2410  IF Y=1985 THEN B=17.3596
2420  IF Y=1986 THEN B=17.3755
2430  IF Y=1987 THEN B=17.3915
2440  T0=DTOT*0.0657098 - B
2450  IF Y<1985 OR Y>1987 THEN GOTO 2990
2460  REM PRINT:INPUT"DO YOU WISH ALTITUDE AND AZIMUTH COORDINATES?(BETWEEN 1985 AND 1987) (Y/N)",AL$
2470  REM IF AL$ <> "Y" AND AL$<>"y" THEN 2760
2480  REM INPUT"LOCAL TIME IN GMT HOURS(0 TO 23) ",HOURS
2490  REM INPUT"            MINUTES(0 TO 59) ",MINUT
2500  REM GMT=HOURS+MINUT/60
2510  GST=GMT*1.00274+T0
2520  IF GST>24 THEN GST=GST-24
2530  IF GST<0 THEN GST=GST+24
2540  REM---------------------------------------------------------
2550  REM                  COMPUTATION OF LST
2560  REM ---------------------------------------------------------
2570   REM PRINT"ENTER LONGITUDE"
2580  REM INPUT LONG
2590  REM ******* ORIGINAL PROGRAM SET TO LONG OF CLEAR LAKE CITY, TEXAS
2600  LONG=-79.6667:REM <---******** CHANGE THIS TO YOUR LONGITUDE
2610  LST=GST+LONG/15
2620  IF LST>24 THEN LST=LST-24
2630  IF LST<0 THEN LST=LST+24
2640  REM ----------------------------------------------------------
2650  REM                COMPUTATION OF HOUR ANGLE
2660  REM ----------------------------------------------------------
2670  HA=LST-N1
2680  REM ----------------------------------------------------
2690  REM COMPUTATION OF HOUR ANGLE AND DECLINATION TO AZ AND EL
2700  REM ----------------------------------------------------------
2710  P=3.14159: R1=P/180
2720  R=HA*15*P/180
2730  D=Y2*P/180
2740  REM INPUT "LAT, LONG   ";B,L
2750  REM ******ORIGINAL PROGRAM LONG LAT SET FOR CLEAR LAKE CITY,TEXAS
2760  B=40.8:L=-79.6667:REM <---******** CHANGE THIS TO YOUR LATITUDE(B) AND LONGITUDE(L).
2770  B=B*R1: L=L*R1
2780  T5=R
2790  S1=SIN(B)*SIN(D)
2800  S1=S1+COS(B)*COS(D)*COS(T5)
2810  C1=1-S1*S1
2820  IF C1>0 THEN C1=SQR(C1)
2830  IF C1<=0 THEN 2850
2840  H=ATN(S1/C1): GOTO 2860
2850  H=SGN(S1)*P/2
2860  C2=COS(B)*SIN(D)
2870  C2=C2-SIN(B)*COS(D)*COS(T5)
2880  S2=-COS(D)*SIN(T5)
2890  IF C2=0 THEN A=SGN(S2)*P/2
2900  IF C2=0 THEN 2930
2910  A=ATN(S2/C2)
2920  IF C2<0 THEN A=A+P
2930  IF A<0 THEN A=A+2*P
2940  PRINT
2950  PRINT "ALTITUDE: ";H/R1;" DEGREES ABOVE HORIZON"
2960  PRINT "AZIMUTH:  ";A/R1;" DEGREES FROM TRUE NORTH"
2970  PRINT:PRINT"ALT AND AZ FOR GMT TIME AS DECIMAL HOURS = ";GMT" FOR GMT DAY =";DDDD
2980  PRINT:PRINT"ALT AND AZ FOR LOCAL TIME AS HOURS,MINUTES = " ;HOURS;",";MINUT" FOR LOCAL DAY = ";DDD
2990  LOCATE 23,1:INPUT"MORE? (Y/N)",QQQ$
3000  IF QQQ$="Y" OR  QQQ$="y" THEN 130
3010  END
3020  REM  SEXAGESIMAL TO DECIMAL
3030  REM
3040  S=1: A1=ABS(VAL(A$))
3050  IF LEFT$(A$,1)="-" THEN S=-1
3060  A=S*(A1+A2/60+A3/3600)
3070  RETURN
3080  END
3090  REM -------------------------------------------------------------------
3100  REM INFO ON HALLEY'S
3110  '  COLOR 0,14,0
3120  CLS
3130  PRINT:PRINT:PRINT"HALLEY'S COMET ORBITS THE SUN IN A HIGHLY ELLIPTICAL ORBIT ONCE EVERY 76 YEARS. THE LAST CLOSEST APPROACH TO THE SUN AND EARTH WAS IN 1910."
3140  PRINT:PRINT"LAST OBSERVED VISUALLY BY E.E. BARNARD ON MAY 23,1911 WITH YERKES 40 INCH       REFRACTOR."
3150  PRINT:PRINT"RECOVERED BY ELECTRONIC PHOTOGRAPH BY G.E.DANIELSON AND D.C.JEWETTON OCTOBER 16,1982 WITH 200 INCH HALE TELESCOPE AT PALOMAR OBSERVATORY,CA.  MAGNITUDE 24.5."
3160  PRINT:PRINT"RECOVERED VISUALLY BY S.J.O'MEARA ON JANUARY 22, 1985 WITH 24 INCH TELESCOPE    ATOP MAUNA KEA, HAWAII.  MAGNITUDE 19.1."
3170  PRINT:PRINT"RECOVERED BY ELECTRONIC PHOTOGRAPH BY R. SCHILD FEBRUARY 16, 1985 WITH 24 INCH  REFLECTOR AT THE WHIPPLE OBSERVATORY IN SOUTHERN ARIZONA.  MAGNITUDE WAS 18."
3180  PRINT:PRINT"PERIHELION (CLOSEST APPROACH TO SUN) FEB. 9.45174, 1986"
3190  PRINT:PRINT"1ST CLOSEST APPROACH TO EARTH NOV. 27, 1985."
3200  PRINT:PRINT"2ND CLOSEST APPROACH TO EARTH APR. 11, 1986."
3210  PRINT:PRINT"DETERMINE FROM THIS PROGRAM WHEN IT WILL BE VISIBLE TO THE NAKED EYE OR IN A    TELESCOPE, AND THE DISTANCE TO THE EARTH AT THE TWO CLOSEST APPROACHES."
3220  IN$=INKEY$:IF IN$<>"" THEN 130 ELSE 3220
3230  REM --------------------------------------------------------------------
3240  REM INFO ON SIZE OF TELESCOPE TO USE
3250  COLOR 15,4,7
3260  CLS:RESTORE
3270  DATA 1,2,3,4.25,6,8,10,13.1
3280  DATA 9.0,10.6,11.5,12.3,13.0,13.7,14.1,14.7
3290  FOR DD=1 TO 8
3300  READ DIA(DD)
3310  NEXT DD
3320  FOR MM=1 TO 8
3330  READ MAGT(MM)
3340  NEXT MM
3350  LOCATE 7,15:PRINT"DIAMETER OF TELESCOPE REQUIRED TO SEE A GIVEN MAGNITUDE"
3360  LOCATE 9,20:PRINT"DIAMETER (INCHES)                   MAGNITUDE"
3370  LOCATE 11,23:PRINT"0.236 (HUMAN EYE)":LOCATE 11,58:PRINT 6
3380  FOR TT=1 TO 8
3390  LOCATE 11+TT,26:PRINT DIA(TT):LOCATE 11+TT,58:PRINT MAGT(TT)
3400  NEXT TT
3410  LOCATE 21,5:PRINT"A MAGNITUDE DIFFERENCE OF 1.0 IS A BRIGHTNESS DIFFERENCE OF 2.512"
3420  PRINT:PRINT"    A MINUS MAGNITUDE IS BRIGHTER THAN A POSITIVE MAGNITUDE"
3430  PRINT:PRINT"    THE NORTH STAR (POLARIS) HAS A MAGNITUDE OF 1.99"
3440  PRINT:PRINT"    THE ANDROMEDA GALAXY HAS A MAGNITUDE OF 6"
3450  IN$=INKEY$:IF IN$<>"" THEN 130 ELSE 3450
3460  REM --------------------------------------------------------------------
3470  COLOR 2,0,4:CLS:LOCATE 1,25:PRINT"COORDINATES OF YOUR LOCATION"
3480  PRINT:PRINT"THE LONGITUDE AND LATITUDE ARE IN THE PROGRAM FOR CLEAR LAKE CITY, TEXAS. TO    CHANGE FOR YOUR LOCATION CHANGE LINES 2400 AND 2550. NOTICE THAT WEST LONGITUDE IS ENTERED AS A NEGATIVE NUMBER. BOTH AS DECIMAL DEGREES."
3490  PRINT:PRINT"THE MORE ACCURATELY YOU CAN DETERMINE YOUR LATITUDE AND LONGITUDE THE MORE      ACCURATE THE ALTITUDE AND AZIMUTH COORDINATES AND SIDERAL TIME."
3500  PRINT:PRINT"DEPENDING UPON THE DATE AND TIME THE PROGRAM MAY LIST THE DATE AS ONE MORE THAN THAT MONTH CAN HAVE, BUT THE PROGRAM IS CORRECT. FOR EXAMPLE, DEC 32, 1985 IS   REALLY JAN 1, 1986."
3510  PRINT:PRINT:PRINT"A DISTANCE OF 1 AU IS THE DISTANCE FROM THE EARTH TO THE SUN, THAT IS, APPROXI- MATELY 92,960,000 MILES."
3520  IN$=INKEY$:IF IN$<>"" THEN 130 ELSE 3520
3530  REM
3540  REM ****************************************************************
3550  REM *                                                              *
3560  REM *     THIS PROGRAM WITH SOURCES NOTED BY                       *
3570  REM *         MICHAEL C. ROBEL                                     *
3580  REM *          1027 MONTOUR                                        *
3590  REM *        HOUSTON, TX 77062                                     *
3600  REM ****************************************************************
3610  REM ****************************************************************
3620  REM MAGNITUDE FROM ORIGINAL PROGRAM CHANGED TO FORMULAS IN "INTERNATIONAL  HALLEY WATCH" BY STEPHEN J. EDBERG OF JPL.
3630  REM ***************************************************************
3640  REM *                  SOURCES
3650  REM * ROGER BROWNE in Astronomy Feb 1985
3660  REM * ROGER W. SINNOTT in Sky and Telescope May 1984
3670  REM * ROGER W. SINNOTT in Sky and Telescope June 1984 (Listing 2)
3680  REM * INTERNATIONAL HALLEY WATCH by STEPHEN J. EDBERG of JPL
3690  REM *****************************************************************
3700  REM *******************SUBROUTINE ADDED FOR TIME ZONE,TIME TO GMT,GST
3710  CLS:DDD=D
3720  LOCATE 4,7:PRINT"PROGRAM TO CONVERT YOUR LOCAL TIME TO GMT TIME AND LOCAL SIDERAL TIME"
3730  LOCATE 6,7:PRINT"KEY EXAMPLES:  EST=Eastern Standard Time     CDT=Central Daylight Time"
3740  LOCATE 8,30:PRINT"EDT             4"
3750  LOCATE 10,30:PRINT"EST OR CDT      5"
3760  LOCATE 12,30:PRINT"CST OR MDT      6"
3770  LOCATE 14,30:PRINT"MST OR PDT      7"
3780  LOCATE 16,30:PRINT"PST             8"
3790  LOCATE 20,22:INPUT"ENTER A NUMBER FOR YOUR TIME ZONE ",TZC
3800  IF TZC <4 OR TZC >8 THEN 3700
3810  LOCATE 22,10:INPUT"LOCAL TIME IN 24 HOUR FORMAT (0 TO 23) ",HOURS
3820  LOCATE 23,10:INPUT"                     MINUTES (0 TO 59) ",MINUT
3830  GMT=HOURS + MINUT/60 + TZC
3840  IF GMT>24 THEN D=D+1:IF GMT>24 THEN GMT=GMT-24
3850  DDDD=D
3860  RETURN
